/*
  1 Boolean array b(0;1) integer k, i, j,
  2 comment process i, with i either 0 or 1 and j = 1-i;
  3 C0: b(i) := false;
  4 C1: if k != i then begin
  5 C2:   if not (b(j) then go to C2;
  6       else k := i; go to C1 end;
  7     else critical section;
  8     b(i) := true;
  9     remainder of program;
 10     go to C0;
 11     end
*/

bool b[2];
byte k;
byte mutex;

active[2] proctype process(){
  /* to make sure, that there is no other proces;
     now _pid corresponds to _pid
   */
  assert(_pid==0 || _pid==1);

C0:
  b[_pid]=0;
C1:
  if
	:: k!=_pid ->
C2:	   
	   if
		 :: !b[1-_pid] -> goto C2;
		 :: else       -> k=_pid; goto C1;
	   fi;
	:: else
	   mutex++;
	   printf("%d in cirt section with %d count\n",_pid,mutex);
	   assert(mutex==1);
	   mutex--;
	   b[_pid]=1;
	   goto C0;
  fi;
}