
#define EVERY_PROC_INFINITLYOFTEN 1

byte mutex;
pid mutex_pid;

mtype { token };

proctype processor(chan left; chan right){

  assert(_pid>=1 && _pid<=4);

  do
	:: left?token ;

	   mutex++;
	   mutex_pid=_pid;
	   assert(mutex==1);
progress1:
	   printf("%d is working\n",_pid);
	   mutex--;

	   if
		 :: left!token;
		 :: right!token;
	   fi;
	:: right?token ;

	   mutex++;
	   mutex_pid=_pid;
	   assert(mutex==1);
progress2:
	   printf("%d is working\n",_pid);
	   mutex--;

	   if
		 :: left!token;
		 :: right!token;
	   fi;
  od;
}

init{
  chan c1 = [1] of { mtype };
  chan c2 = [1] of { mtype };
  chan c3 = [1] of { mtype };
  chan c4 = [1] of { mtype };

  if
	:: c1!token;
	:: c2!token;
	:: c3!token;
	:: c4!token;
  fi;
  
  atomic{
	run processor(c1,c2);
	run processor(c2,c3);
	run processor(c3,c4);
	run processor(c4,c1);
  }
}


#define c1 (mutex_pid==1 && mutex==1)
#define c2 (mutex_pid==2 && mutex==1)
#define c3 (mutex_pid==3 && mutex==1)
#define c4 (mutex_pid==4 && mutex==1)

#if EVERY_PROC_INFINITLYOFTEN == 1

never {    /* !(([]<>c1) && ([]<>c2) && ([]<>c3) && ([]<>c4)) */
T0_init:
	if
	:: (! ((c4))) -> goto accept_S7
	:: (! ((c3))) -> goto accept_S12
	:: (! ((c2))) -> goto accept_S17
	:: (! ((c1))) -> goto accept_S22
	:: (1) -> goto T0_init
	fi;
accept_S7:
	if
	:: (! ((c4))) -> goto accept_S7
	fi;
accept_S12:
	if
	:: (! ((c3))) -> goto accept_S12
	fi;
accept_S17:
	if
	:: (! ((c2))) -> goto accept_S17
	fi;
accept_S22:
	if
	:: (! ((c1))) -> goto accept_S22
	fi;
}

#endif
